Package: MantelCorr
Title: Compute Mantel Cluster Correlations
Version: 1.83.0
Date: 2005-17-10
Author: Brian Steinmeyer and William Shannon
Description: Computes Mantel cluster correlations from a (p x n)
        numeric data matrix (e.g. microarray gene-expression data).
Maintainer: Brian Steinmeyer <steinmeb@ilya.wustl.edu>
Depends: R (>= 2.10)
Imports: stats
License: GPL (>= 2)
biocViews: Clustering
git_url: https://git.bioconductor.org/packages/MantelCorr
git_branch: devel
git_last_commit: 3b313ab
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:31:43 UTC; biocbuild

######################################################################
# Function MantelCorrs() computes each cluster's mantel correlation, #
# correlating its distance matrix with Dfull                         #
#                                                                    #
# Input Parameters:                                                  # 
# 1) Distance Matrix using all p variables (genes).                  #
# 2) Distance Matrices for each kth cluster Dsubset{k}               #
#                                                                    #
# Returns to the end user:                                           #
# 1) a list of k mantel correlations from the RunKmeans() algorithm  #
#                                                                    #
# Date:  August 12, 2005                                             #
# written by:  Brian Steinmeyer                                      #
######################################################################


## correlate each cluster's distance matrix with
## "Dfull" using the Mantel correlation


MantelCorrs <- function(Dfull, Dsubsets)  {
       mantel <- function(a, b) cor(a,b)
       mantel.cors <- lapply(Dsubsets, mantel, Dfull)
  return(mantel.cors)
}




 

############################################################################
# Function "GetClusters()" uses the kmeans() function in R; partitions the # 
# gene-space                                                               #
#                                                                          #
# Input parameters:                                                        #
# 1) Data - does not use the first two columns                             #
# 2) choice of k                                                           #
# 3) number of iterations                                                  #
#                                                                          #
# Returns to the end user:                                                 #
# 1) cluster assignment from the kmeans() function                         #
# 2) size of each cluster k                                                # 
#                                                                          #
# Date:  August 12, 2005                                                   #
# written by:  Brian Steinmeyer                                            #
############################################################################


## over-partition (one-half the number of variables, p) the gene-space using
## kmeans.  Return kmeans cluster assignment and size to the user

## declare original data
## use only gene-expression values
# data <- <your data>

GetClusters <- function(x.data, num.k, num.iters)  {
   p <- kmeans(x.data, num.k, num.iters)        
   clus <- p$cluster                      
   clus.size <- p$size
 return(list(clusters=clus, cluster.sizes=clus.size))
}

###################################################################################
# Function PermutationTest() obtains a p-value of significance from a permutation # 
# test of Dfull.  Uses MantelCorr().                                              #
#                                                                                 #
# Input Parameters:                                                               #
# 1) Dfull (distance matrix using all p variables)                                #
# 2) Dsubsets (individual cluster distance matrices)                              #
# 3) number of permutations                                                       #
# 4) number of samples (chips)                                                    #
# 5) desired alpha-level of significance                                          #
#                                                                                 #
# Returns to the end user:                                                        #
# 1) permuted p-value for the alpha-chosen level of significance                  #
#                                                                                 #
# Date:  August 12, 2005                                                          #
# written by:  Brian Steinmeyer                                                   #
###################################################################################


## permute rows and columns "num.permute" times
## to destroy the dependent nature of Dfull

## for each permutation, recalculate the mantel correlation
## of "Dfull" with each cluster's distance matrix, and
## retain the maximum Mantel correlation


PermutationTest <- function(Dfull, Dsubsets, num.per, num.chips, alpha)
{
     mantel <- function(a, b) cor(a,b) 
     permute <- NULL                             
     for (i in 1:num.per)                        
     {                                           
       distmat <- as.matrix(Dfull)           
       x <- sample(1:num.chips)                  
       distmat <- as.dist(distmat[x,x])          
       permute <- cbind(permute, max(abs(as.numeric(lapply(Dsubsets, mantel, distmat)))))
     }
   cut.value1 <- quantile(as.vector(permute), probs = (1 - alpha))
 return(cut.value1)
}
      
## select the "alpha" percentile from the empirical distribution
## of the maximum Mantel correlations found in the permutation
## test as the critical value for determining cluster significance.
## return its value to the end user

##########################################################################################
# Function ClusterGeneList() returns both significant and nonsignificant genes from each # 
# type of cluster                                                                        #
#                                                                                        #
# Input Parameters:                                                                      #
# 1) cluster assignment from the kmeans algorithm                                        #
# 2) significant cluster list returned from ClusterList                                  #
# 3) original data                                                                       #
#                                                                                        #
# Returns:                                                                               #
# 1) Two lists of both significant and nonsignificant cluster genes                      #
#                                                                                        #
# Date:  August 12, 2005                                                                 #
# written by:  Brian Steinmeyer                                                          #
##########################################################################################


## create and return genes from all significant and non-significant clusters

ClusterGeneList <- function(clus, clustlist.sig, x.data)  {
      
     store.clus <- rep(0, length(clus))
         for (i in clustlist.sig[,1]) store.clus[clus==i] <- 1
            cluster.genes.sig <- x.data[store.clus==1,]
            cluster.genes.nonsig <- x.data[store.clus==0,]

     SigGenes <- dimnames(cluster.genes.sig)[[1]]
     NonSigGenes <- dimnames(cluster.genes.nonsig)[[1]]

  return(list(SignificantClusterGenes=SigGenes, NonSignificantClusterGenes=NonSigGenes))
}

##############################################################################
# Function "DistMatrices()" computes similarity matrices for the data matrix # 
# and each cluster                                                           #
#                                                                            #
# Input Parameters:                                                          #
# 1) Data                                                                    #
# 2) Cluster assignment vector from RunKmeans() function                     #
#                                                                            #
# Returns to the end user:                                                   #
# 1) D_Full                                                                  #
# 2) D_Subset{i}                                                             #
#                                                                            #
# Date:  August 12, 2005                                                     #
# written by:  Brian Steinmeyer                                              #
##############################################################################


## calculate Euclidean distance matrix for all samples
## calculate Euclidean distance matrix for each cluster
## return to end user


DistMatrices <- function(x.data, cluster.assignment)  {
       tdist <- function(p) dist(t(p))
       dist.full <- dist(t(x.data))                    
       Dsub.i <- by(x.data, cluster.assignment, tdist)                 
  return(list(Dsubsets=Dsub.i, Dfull=dist.full))
}

############################################################################
# Function ClusterList() returns two lists containing both significant and #
# nonsignificant clusters, based on the permuted p-value found previously  #
#                                                                          #
# Input Parameters:                                                        #
# 1) permuted p-value                                                      #
# 2) cluster sizes                                                         #
# 3) original k mantel cluster correlations                                #
#                                                                          #
# Returns:                                                                 #
# 1) list of significant clusters (with cluster number, Mantel cluster     #
#    correlation, cluster size)                                            #
# 2) list of nonsignificant clusters with identical information as in (1)  #
#                                                                          #
# Date:  August 12, 2005                                                   #
# written by:  Brian Steinmeyer                                            #
############################################################################


## Create and return information for both significant and non-significant 
## clusters (based on the critical value), including:  cluster number, mantel 
## cluster correlation and cluster size


ClusterList <- function(p.val, clus.size, mantel.cors)  {
   
  ## list the original k Mantel cluster correlations 
  clust.list <- cbind(as.numeric(names(mantel.cors)), as.numeric(mantel.cors), 
                as.numeric(clus.size))

  ## return cluster lists to the user as a data frame with the appropriate 
  ## column headings
  clustlist.sig <- as.data.frame(clust.list[abs(clust.list[,2]) >= p.val, , drop=FALSE])
  names(clustlist.sig) <- c("significant cluster", "Mantel correlation", "cluster size")

  clustlist.nonsig <- as.data.frame(clust.list[abs(clust.list[,2]) < p.val, , drop=FALSE])
  names(clustlist.nonsig) <- c("nonsignificant cluster", "Mantel correlation", "cluster size")
 return(list(SignificantClusters=clustlist.sig, NonSignificantClusters=clustlist.nonsig))
}

% \VignetteDepends{stats}
% \VignetteIndexEntry{MantelCorrVignette}
% \VignetteKeywords{Cluster}
% \VignettePackage{MantelCorr}
\documentclass[11pt]{article}

\usepackage{epsfig}
\usepackage{latexsym}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsfonts}
\usepackage{amsxtra}
\usepackage{graphicx,subfigure}
\usepackage{vmargin}

\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\texttt{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Rfunarg}[1]{{\texttt{#1}}}

\parindent 0in
\setpapersize{USletter}
\setmarginsrb{1truein}{0.5truein}{1truein}{0.5truein}{16pt}{30pt}{0pt}{20truept}
\setlength{\emergencystretch}{2em}
\begin{document}

\title{MantelCorr Package for Bioconductor}
\author{Brian Steinmeyer, MS, and William Shannon, PhD\\
Department of Internal Medicine \\
Division of General Medical Sciences \\
Washington University in St. Louis \\
School of Medicine \\
email: \texttt{steinmeb@ilya.wustl.edu, wshannon@wustl.edu}}

\maketitle
\bibliographystyle{plain}
\tableofcontents

% library(tools)
% testfile <- file.path("/home/steinmeb/RpackageCreation2/MantelCorrTest2/inst/doc", "mantelcorr_vignette.Rnw") 
% Sweave(testfile)

\section{Description}

The \Rpackage{MantelCorr} package is based on the methodology developed in Shannon et al. \cite{shannon05},
for which six functions are used to locate and identify important gene 
clusters from standard microarray expresssion data with \Robject{p} genes (\emph{rows}) and \Robject{n} samples (\emph{columns}).  
Mantel statistics have been applied with success to correlate gene expression levels with clinical covariates \cite{shannon02}.
We also include a real microarray dataset with the package to help illustrate its functionality.  Specifically, 
the package makes use of the \Robject{k-means()} function in \Robject{R} (\emph{with arbitrary \Robject{k}, 
say \Robject{k} $\in$ [5, \Robject{$\frac{p}{{2}}$}]})
to essentially over-partition the gene space into \Robject{k} non-overlapping clusters.  Next, two types 
of dissimilarity matrices are computed, one based on the original data \Robject{Dfull}, and one for each 
resultant cluster, \Robject{Dsubset(k)}.\\  


Mantel \cite{mantel67} cluster correlations are then found by correlating each \Robject{Dsubset(k)} with \Robject{Dfull}, 
resulting in \Robject{k} Mantel correlations.  In order to destroy the distance dependent nature of 
\Robject{Dfull} and to obtain an empirical null distribution of distance independence, a permutation test 
is done, where the number of permutations and $\alpha$ significance level parameters can be chosen by the user.
Specifically, the significance level provides the criterion value (\emph{p-value}) at which a given cluster is considered 
significant or non-significant.  Both significant and non-significant cluster lists can be viewed with the 
\Rfunction{ClusterList} function.  In addition, a summary list of genes within these clusters can
also be seen with the \Rfunction{ClusterGeneList} function.\\


We next introduce a simple application of the \Rfunction{MantelCorr} package with gene-expression training data taken from the 
Golub et al. \cite{golub99} leukemia study.\\



\section{Example \Robject{R} session with the Golub training data}

The Golub training data consists of gene-expression values measured for 38 samples from Affymetrix Hgu6800 chips on 
$7,129$ genes.  There are $27$ acute lymphoblastic leukemia (\Robject{ALL}) and $11$ acute myeloid leukemia (\Robject{AML}) samples. To load
the \Rpackage{MantelCorr} package, simply type \texttt{library(MantelCorr)}.
The data can be loaded by typing \texttt{data(GolubTrain)} and a description provided with \texttt{?GolubTrain}.\\

<<preliminaries>>=
library(MantelCorr)
data(GolubTrain)
dim(GolubTrain)
data <- GolubTrain
@


\section{Reminder}
Help on any of the following \Rpackage{MantelCorr} package functions can be viewed 
by \texttt{?FunctionName}, which provides a complete description and overview of the 
function's purpose and syntax.  In addition, all input 'data' values are \Robject{assumed}
to be interval-scale (e.g., numeric data), with gene and sample labels assigned from the 
\Robject{dimnames()} function.\\



\section{\Robject{GetClusters()} function}
The \Rfunction{GetClusters()} function over-partitions the gene-space as described in the package description.  We 
select \Robject{k = 500} clusters and store the result in an object called "kmeans.result".\\

<<GetClusters>>=
kmeans.result <- GetClusters(data, 500, 100)
@


\section{\Robject{DistMatrices()} function}

A function used to compute distance matrices \Robject{Dfull} and \Robject{Dsubset(k)} from the \Robject{k} 
non-overlapping clusters stored in "kmeans.result".  The result is assigned to "DistMatrices.result".\\

<<DistMatrices>>=
DistMatrices.result <- DistMatrices(data, kmeans.result$clusters)
@

\section{\Robject{MantelCorrs()} function}

The \Rfunction{MantelCorrs()} function uses \Robject{Dfull} and \Robject{Dsubset(k)} to compute a Mantel correlation 
for each \Robject{kth} cluster by correlating these two dissimilarity matrices.  The result is saved in 
"MantelCorrs.result".\\

<<MantelCorrs>>=
MantelCorrs.result <- MantelCorrs(DistMatrices.result$Dfull, DistMatrices.result$Dsubsets)
@


\section{\Robject{PermutationTest()} function}
\Rfunction{PermutationTest()} permutes \Robject{Dfull} to obtain an empirical null distribution for which
cluster significance is determined.  We have selected 100 permutations in order to conserve CPU time, and 
chosen an $\alpha$-value of 0.05 for the 38 Golub leukemia samples. The result is stored in an object called
"permuted.pval".  \Robject{NOTE:}  we recommend using at least 1000 permutations for a thorough analysis.\\

<<PermutationTest>>=
permuted.pval <- PermutationTest(DistMatrices.result$Dfull, DistMatrices.result$Dsubsets, 100, 38, 0.05)
@


\section{\Robject{ClusterList()} function}
A function used to generate a complete list of both significant and non-significant clusters
found by the permutation test and associated level of significance.  Cluster size and correlation 
are provided with each type of cluster.  We assign 
the result to the \Robject{R} object "ClusterLists" as follows:\\


<<ClusterList>>=
ClusterLists <- ClusterList(permuted.pval, kmeans.result$cluster.sizes, MantelCorrs.result)
@


\section{\Robject{ClusterGeneList()} function}
A final function that uses information from the "ClusterList" function, coupled with the \Robject{dimnames}
function to generate a composite list of the genes found in both cluster types (significant and non-significant).  
We store the result in \Robject{R} object "ClusterGenes".\\


<<ClusterGeneList>>=
ClusterGenes <- ClusterGeneList(kmeans.result$clusters, ClusterLists$SignificantClusters, data)
@

% <<fig=TRUE, include=FALSE>>=
% @



% \bibliography{qvalue} 

% \begin{figure}[ht]
%  \begin{center}
%    \includegraphics[width=5in,height=5in]{pHist}
%  \end{center}
%  \caption{Histogram of p-values.}
% \end{figure}

% \begin{figure}[ht]
%  \begin{center}
%    \includegraphics[width=5in,height=5in]{qHist}
%  \end{center}
%  \caption{Histogram of q-values.}
% \end{figure}


\begin{thebibliography}{9}
	
	\bibitem{shannon05}
          Shannon, Steinmeyer, Li, Culverhouse, Grefenstette, Thompson. (2005)
	  \emph{Variable Selection in Cluster Analysis Using k-means and Mantel Correlation}.
           Computing Science and Statistics (To Appear).


	\bibitem{mantel67}
	  Mantel, N.
	  \emph{The Detection of Disease and a Generalized Regression Approach}.
	  Cancer Research, 27, 209-220, 1967.


	\bibitem{shannon02}
          Shannon W, Watson M, Perry A, Rich K. 
          \emph{Mantel statistics to correlate gene expression levels from microarrays with clinical covariates}.
           Genetic Epidemiology 2002; 23:87-96.


	\bibitem{golub99}
          Golub, T. et al.
	  \emph{Molecular Classification of Cancer: Class Discovery and Class Prediction by Gene Expression
           Monitoring}.
          Science, 531-537, 1999.

\end{thebibliography}

\end{document}

\name{ClusterGeneList}

\alias{ClusterGeneList}

\title{ Generate Genes from a Cluster List }
\description{
  'ClusterGeneList' produces a list of both significant and
   nonsignificant genes from each respective cluster type
}

\usage{
ClusterGeneList(clus, clustlist.sig, x.data)
}

\arguments{
  \item{     clus}{ 'clusters' object returned by 'GetClusters' }
  \item{     clustlist.sig}{ 'SignificantClusters' object returned by 'ClusterList'}
  \item{     x.data}{ original (p x n) numeric data matrix (e.g., gene-expression data)}
}

\value{
  A list with components:
  \item{     SignificantClusterGenes }{significant cluster genes returned from 'ClusterList'}
  \item{     NonSignificantClusterGenes }{nonsignificant cluster genes returned from 'ClusterList'}
}

\author{ Brian Steinmeyer }

\note{ argument 'x.data' should have an ID gene variable, 'probes', attached as a 'dimnames'
attribute}

\seealso{ 'GetClusters' 'ClusterList' }

\examples{
%\dontrun{
# simulate a p x n microarray expression dataset, where p = genes and n = samples
data.sep <- rbind(matrix(rnorm(1000), ncol=50), matrix(rnorm(1000, mean=5), ncol=50))
noise <- matrix(runif(40000), ncol=1000)
data <- t(cbind(data.sep, noise))
data <- data[1:200, ]
# data has p = 1,050 genes and n = 40 samples

clusters.result <- GetClusters(data, 100, 100)
dist.matrices <- DistMatrices(data, clusters.result$clusters)
mantel.corrs <- MantelCorrs(dist.matrices$Dfull, dist.matrices$Dsubsets)
permutation.result <- PermutationTest(dist.matrices$Dfull, dist.matrices$Dsubsets, 100, 40, 0.05)

# generate both significant and non-significant gene clusters
cluster.list <- ClusterList(permutation.result, clusters.result$cluster.sizes, mantel.corrs)

# significant and non-significant cluster genes (expression values)
cluster.genes <- ClusterGeneList(clusters.result$clusters, cluster.list$SignificantClusters, data)

}
%}

\keyword{ cluster }% at least one, from doc/KEYWORDS

\name{GolubTrain}

\alias{GolubTrain}

\docType{data}

\title{ Golub Training Set }

\description{
  Samples were taken with Affymetrix Hgu6800 chips and expression levels measured on 7,129
  genes (probes).  The samples consist of 27 acute lymphoblastic leukemia (ALL) and 11 acute
  myeloid luekemia (AML) patients.  The data values are raw (e.g. no standardization or
  gene filtering applied).
}

\usage{data(GolubTrain)}

\format{
  A data frame of 7129 observations (genes) with the following 38 variables (samples):
  \describe{
    \item{X1}{ALL}
    \item{X2}{ALL}
    \item{X3}{ALL}
    \item{X4}{ALL}
    \item{X5}{ALL}
    \item{X6}{ALL}
    \item{X7}{ALL}
    \item{X8}{ALL}
    \item{X9}{ALL}
    \item{X10}{ALL}
    \item{X11}{ALL}
    \item{X12}{ALL}
    \item{X13}{ALL}
    \item{X14}{ALL}
    \item{X15}{ALL}
    \item{X16}{ALL}
    \item{X17}{ALL}
    \item{X18}{ALL}
    \item{X19}{ALL}
    \item{X20}{ALL}
    \item{X21}{ALL}
    \item{X22}{ALL}
    \item{X23}{ALL}
    \item{X24}{ALL}
    \item{X25}{ALL}
    \item{X26}{ALL}
    \item{X27}{ALL}
    \item{X28}{AML}
    \item{X29}{AML}
    \item{X30}{AML}
    \item{X31}{AML}
    \item{X32}{AML}
    \item{X33}{AML}
    \item{X34}{AML}
    \item{X35}{AML}
    \item{X36}{AML}
    \item{X37}{AML}
    \item{X38}{AML}
  }
}

\source{
  http://www.broad.mit.edu/cgi-bin/cancer/datasets.cgi
}

\references{
  Golub, T.R. Molecular Classification of Cancer:  Class Discovery and Class
  Prediction by Gene Expression Monitoring.  Science, vol 286, 531-537, 1999.
}

\examples{
data(GolubTrain)
}

\keyword{datasets}

\name{GetClusters}

\alias{GetClusters}

\title{Over-Partition a (p x n) Data Matrix using 'kmeans'}

\description{
  'GetClusters' uses an overly large k with the 'kmeans'
   function to over-partition p variables (rows = genes) from n
   objects (cols = samples) from a given data matrix 'x.data'}

\usage{
GetClusters(x.data, num.k, num.iters)
}

\arguments{
  \item{     x.data}{p x n data matrix of numeric values}
  \item{     num.k}{number of k partitions desired}
  \item{     num.iters}{number of iterations - recommend >= 100}
}

\value{
  'GetClusters' returns a list with the following components:

  \item{     clusters}{cluster assignment from 'kmeans'}
  \item{     cluster.sizes}{size of each cluster k from 'kmeans'}
}

\author{ Brian Steinmeyer }

\note{The input data matrix, x.data, must be numeric (e.g., gene-expression values).
      We recommend using 'num.k' = one-half the number of genes and 'num.iters' greater than 50}


\seealso{'kmeans'}


\examples{
%\dontrun{
# simulate a p x n microarray expression dataset, where p = genes and n = samples
data.sep <- rbind(matrix(rnorm(1000), ncol=50), matrix(rnorm(1000, mean=5), ncol=50))
noise <- matrix(runif(40000), ncol=1000)
data <- t(cbind(data.sep, noise))
data <- data[1:200, ]
# data has p = 1,050 genes and n = 40 samples

clusters.result <- GetClusters(data, 100, 100)

}
%}

\keyword{ cluster } % at least one, from doc/KEYWORDS

\name{PermutatonTest}

\alias{PermutationTest}

\title{ Permutation Test for Dissimilarity Matrices }

\description{
  'PermutationTest' computes and returns an empirical p-value from a 
  null distribution generated by permuting 'Dfull' a total of 'num.per' times.
}


\usage{
PermutationTest(Dfull, Dsubsets, num.per, num.chips, alpha)
}


\arguments{
  \item{     Dfull}{dissimilarity matrix from the original (p x n) microarray expression data}
  \item{     Dsubsets}{dissimilarity matrices from each k disjoint clusters returned by 'GetClusters'}
  \item{     num.per   }{number of permutations }
  \item{     num.chips}{number of samples, 'n' from the original (p x n) data matrix }
  \item{     alpha     }{desired level of significance}
}


\details{
  For each permutation, k Mantel correlations are computed by correlating the permuted 'Dfull' with each dissimilarity
  matrix 'Dsubsets' from the 'k' clusters returned by 'GetClusters'.  The absolute value
  of the maximum Mantel cluster correlation is retained at each permutation.  These
  'num.per' maximum correlations are then used to generate a null distribution for
  distance metric independence, with the p-value taken from the (1 - 'alpha') percentile
  of this permutation distribution.
}

\value{
  returns the permuted p-value for the 'alpha' selected level of significance
}

\note{ The function is meant to be executed AFTER 'GetClustes', 'DistMatrices' and 'MantelCorr' (see example) }

\author{ Brian Steinmeyer }

\section{Warning}{ (p x n) data matrix should be numeric (e.g. gene-expression levels) }

\seealso{ 'GetClusters' 'DistMatrices' 'MantelCorrs' }

\examples{
%\dontrun{
# simulate a p x n microarray expression dataset, where p = genes and n = samples
data.sep <- rbind(matrix(rnorm(1000), ncol=50), matrix(rnorm(1000, mean=5), ncol=50))
noise <- matrix(runif(40000), ncol=1000)
data <- t(cbind(data.sep, noise))
data <- data[1:200, ]
# data has p = 1,050 genes and n = 40 samples

clusters.result <- GetClusters(data, 100, 100)
dist.matrices <- DistMatrices(data, clusters.result$clusters)
mantel.corrs <- MantelCorrs(dist.matrices$Dfull, dist.matrices$Dsubsets)
permutation.result <- PermutationTest(dist.matrices$Dfull, dist.matrices$Dsubsets, 100, 40, 0.05)

}
%}

\keyword{ cluster }% at least one, from doc/KEYWORDS

\name{DistMatrices}

\alias{DistMatrices}

\title{Compute Dissimilarity Matrices}

\description{
  'DistMatrices' uses 'dist' to compute dissimilarity matrices for 'data' and
   each cluster k from 'GetClusters'
}

\usage{
 DistMatrices(x.data, cluster.assignment)
}

\arguments{
  \item{      x.data}{ original 'data' matrix }
  \item{      cluster.assignment}{ cluster assignment vector, "clusters", returned by 'GetClusters' }
}

\value{
  returns a list with two components:

  \item{     Dsubsets }{dissimilarity matrices for each cluster k}
  \item{     Dfull }{dissimilarity matrix for the original 'data'}
}

\author{ Brian Steinmeyer }

\note{ 'GetClusters' should be executed prior to 'DistMatrices' }

\seealso{'GetClusters'}

\examples{
%\dontrun{
# simulate a p x n microarray expression dataset, where p = genes and n = samples
data.sep <- rbind(matrix(rnorm(1000), ncol=50), matrix(rnorm(1000, mean=5), ncol=50))
noise <- matrix(runif(40000), ncol=1000)
data <- t(cbind(data.sep, noise))
data <- data[1:200, ]
# data has p = 1,050 genes and n = 40 samples

clusters.result <- GetClusters(data, 100, 100)
dissimilarity.matrices <- DistMatrices(data, clusters.result$clusters)

}
%}

\keyword{ cluster }% at least one, from doc/KEYWORDS

\name{MantelCorrs}

\alias{MantelCorrs}

\title{ Compute Mantel Correlation(s) }

\description{
   'MantelCorrs' computes the Mantel correlation between two
   dissimilarity matrices
}

\usage{
MantelCorrs(Dfull, Dsubsets)
}

\arguments{
  \item{Dfull}{ distance matrix returned by 'DistMatrices' using original 'data' }
  \item{   Dsubsets}{ list of distance matrices from each k cluster or partition returned
                   by 'DistMatrices' }
}

\value{
  A list with k components
  \item{     where component i }{Mantel correlation for cluster i, i = 1,...,k}
}

\references{ Mantel N:  The detection of disease clustering and a generalized regression
             approach.  Cancer Research. 27(2), 209-220 (1967). }


\author{ Brian Steinmeyer }

\note{ the value 'k' corresponds to the parameter 'num.k' in 'GetClusters' }

\seealso{ 'GetClusters' 'DistMatrices' 'kmeans' }

\section{Warning}{ The function is meant to be executed AFTER 'GetClustes' and 'DistMatrices' (see example) }

\examples{
%\dontrun{
# simulate a p x n microarray expression dataset, where p = genes and n = samples
data.sep <- rbind(matrix(rnorm(1000), ncol=50), matrix(rnorm(1000, mean=5), ncol=50))
noise <- matrix(runif(40000), ncol=1000)
data <- t(cbind(data.sep, noise))
data <- data[1:200, ]
# data has p = 1,050 genes and n = 40 samples

clusters.result <- GetClusters(data, 100, 100)
dist.matrices <- DistMatrices(data, clusters.result$clusters)
mantel.corrs <- MantelCorrs(dist.matrices$Dfull, dist.matrices$Dsubsets)

}
%}

\keyword{ cluster }% at least one, from doc/KEYWORDS

\name{ClusterList}

\alias{ClusterList}

\title{ Generate a Cluster List }

\description{
  'ClusterList' generates a list of both significant and nonsignificant
   clusters, with cluster number, Mantel cluster correlation and size
}

\usage{
ClusterList(p.val, clus.size, mantel.cors)
}

\arguments{
  \item{     p.val}{ permutation p-value returned from 'PermutationTest' }
  \item{     clus.size}{ vector of k cluster sizes returned from 'GetCluster' }
  \item{     mantel.cors}{ orignal, unpermuted k Mantel correlations returned from 'MantelCorrs' }
}

\value{
  A list with components:
  \item{     SignificantClusters}{clusters with significant Mantel correlation, equal to or larger
        than the permutation p-value returned by 'PermutationTest'}
  \item{     NonSignificantClusters}{clusters with nonsignificant Mantel correlation, smaller
                than the permutation p-value returned by 'PermutationTest'}
}

\author{ Brian Steinmeyer }

\seealso{ 'PermutationTest' }

\examples{
%\dontrun{
# simulate a p x n microarray expression dataset, where p = genes and n = samples
data.sep <- rbind(matrix(rnorm(1000), ncol=50), matrix(rnorm(1000, mean=5), ncol=50))
noise <- matrix(runif(40000), ncol=1000)
data <- t(cbind(data.sep, noise))
data <- data[1:200, ]
# data has p = 1,050 genes and n = 40 samples

clusters.result <- GetClusters(data, 100, 100)
dist.matrices <- DistMatrices(data, clusters.result$clusters)
mantel.corrs <- MantelCorrs(dist.matrices$Dfull, dist.matrices$Dsubsets)
permutation.result <- PermutationTest(dist.matrices$Dfull, dist.matrices$Dsubsets, 100, 40, 0.05)

# generate both significant and non-significant gene clusters
cluster.list <- ClusterList(permutation.result, clusters.result$cluster.sizes, mantel.corrs)

}
%}

\keyword{ cluster }% at least one, from doc/KEYWORDS
